/* Plug-in to interface to Adobe Photoshop (tm) compatible plug-ins.
 *
 * Copyright (C) 1999 Tor Lillqvist
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * This plug-in works only on Windows, but work is being done
 * to make it work on Linux with the help of Winelib.
 *
 * To build this plug-in you will need the headers from the
 * Photoshop SDK. The SDK is available from http://www.adobe.com.
 */

/* Set to the level of debugging output you want, 0 for release */
#define DEBUGLEVEL 3

#define IFDBG(level) if (DEBUGLEVEL >= level)

#include "config.h"

#include <stdio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <PIGeneral.h>
#include <PIAbout.h>
#include <PIFilter.h>
#include <PIUtilities.h>
#include <WinUtilities.h>

#include <gtk/gtk.h>
#include <libgimp/gimp.h>

#define RECT_EMPTY(r) ((r)->top == (r)->bottom || (r)->left == (r)->right)

static char *piplname = NULL;
static char *pipltype = NULL;

static void
query ()
{
  GParamDef *args;
  GParam *return_vals;
  gint nreturn_vals;

  /* Scan ps-plugin-path for plug-ins, check that they are valid, and
   * install a corresponding PDB procedure.
   */
  return_vals = gimp_run_procedure ("gimp_gimprc_query", &nreturn_vals,
				    PARAM_STRING, "ps-pi-path",
                                    PARAM_END);
  if(return_vals[0].data.d_status != STATUS_SUCCESS
     || return_vals[1].data.d_string == NULL)
    {
      
}

static void
run (char    *name,
     int      nparams,
     GParam  *param,
     int     *nreturn_vals,
     GParam **return_vals)
{
  static GParam values[1];
  GRunModeType run_mode;
  GStatusType status = STATUS_SUCCESS;

  run_mode = param[0].data.d_int32;

  *return_vals = values;
  *nreturn_vals = 1;
  values[0].type = PARAM_STATUS;

  values[0].data.d_status = status;
}

GPlugInInfo PLUG_IN_INFO =
{
  NULL,    /* init_proc */
  NULL,    /* quit_proc */
  query,   /* query_proc */
  run,     /* run_proc */
};

MAIN ()

